Ruby - Bug #5568

I0#set_encoding ignores internal when the same as external only when specified as "ext:int"
11/04/2011 12:49 PM - brixen (Brian Shirai)

Status: Closed
Priority: Normal
Assignee: naruse (Yui NARUSE)

Target version:

ruby -v: ruby 2.0.0dev (2011-10-26 trunk 33526) |Backport:
[x86_64-darwin10.8.0]

Description

When passing two encoding objects that are the same to |O#set_encoding, both external and internal encodings for the IO instance
are set.

However, when passing "ext:int", the internal encoding is not set if the same as external, but a warning is issued. Further, when
passing "ext", "int", the internal encoding is not set and no warning is issued.

sasha:rubinius brian$ ruby2.0 -v -e 'p STDOUT.set_encoding("utf-8:utf-8").internal_encoding'
ruby 2.0.0dev (2011-10-26 trunk 33526) [x86_64-darwin10.8.0]

-e:1: warning: Ignoring internal encoding utf-8: it is identical to external encoding utf-8

nil

sasha:rubinius brian$ ruby2.0 -v -e 'p STDOUT.set_encoding(Encoding::UTF_8, Encoding::UTF_8).internal_encoding'
ruby 2.0.0dev (2011-10-26 trunk 33526) [x86_64-darwin10.8.0]

#Encoding:UTF-8
sasha:rubinius brian$ ruby2.0 -v -e 'p STDOUT.set_encoding("utf-8", "utf-8").internal_encoding'

ruby 2.0.0dev (2011-10-26 trunk 33526) [x86_64-darwin10.8.0]
nil

Is there a reason for these differences?

Thanks,
Brian

Related issues:
Related to Ruby - Bug #6324 : Spurious/incorrect warning on File.open with int... Closed 04/20/2012

Associated revisions

Revision db83618d2c49cbab8b78e31ecf5a8979895bc5d6 - 03/13/2012 04:03 AM - naruse (Yui NARUSE)

e jo.c (io_encoding_set): always warn if external encoding and internal
encoding are identical. [ruby-core:40727] [Bug #5568]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@34997 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision db83618d - 03/13/2012 04:03 AM - naruse (Yui NARUSE)

¢ jo.c (io_encoding_set): always warn if external encoding and internal
encoding are identical. [ruby-core:40727] [Bug #5568]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@34997 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 11/21/2011 03:09 AM - naruse (Yui NARUSE)
- Category set to M17N
- Status changed from Open to Assigned

- Assignee set to naruse (Yui NARUSE)

#2 - 11/29/2011 09:13 PM - naruse (Yui NARUSE)
- Status changed from Assigned to Rejected

Current behavior is correct.
It means the specifying internal encoding won't effect until external encoding is changed.

#3 - 11/30/2011 03:15 AM - brixen (Brian Shirai)

Why is there a difference in behavior when the arguments are different? In other words, ("ext:int") and (ext, int) do not have the same behavior. That's
really the point of this ticket.

#4 - 11/30/2011 04:36 AM - naruse (Yui NARUSE)

- Status changed from Rejected to Assigned

#5 - 03/13/2012 01:03 PM - naruse (Yui NARUSE)
- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r34997.
Brian, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

® jo.c (io_encoding_set): always warn if external encoding and internal
encoding are identical. [ruby-core:40727] [Bug #5568]

06/11/2025 22


bugs.ruby-lang.org/issues/5568
https://bugs.ruby-lang.org/issues/5568
http://www.tcpdf.org

